<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
		<el-form-item label="公司名称" prop="companyId" >
		  <el-select v-model="queryParams.companyId" placeholder="请选择所属公司" filterable size="small">
		    <el-option v-for="(option, index) in companyList" :key="index" :value="option.dictValue" :label="option.dictLabel"></el-option>
		  </el-select>
		</el-form-item>
      <el-form-item label="渠道" prop="source">
        <el-input
          v-model="queryParams.source"
          placeholder="请输入渠道"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item label="企微主体" prop="corpId">
		<el-select v-model="queryParams.corpId" placeholder="请选择所属公司" filterable size="small">
		  <el-option v-for="(option, index) in corpOptions" :key="index" :value="option.corpId" :label="option.corpName"></el-option>
		</el-select>
      </el-form-item>
	   <el-form-item label="创建时间" prop="createTime">
	             <el-date-picker v-model="createTime" size="small" style="width: 220px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期" @change="change"></el-date-picker>
	   </el-form-item>

	  
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          :loading="exportLoading"
          @click="handleExport"
          v-hasPermi="['qw:qwAppContactWayLogs:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table border v-loading="loading" :data="qwAppContactWayLogsList" @selection-change="handleSelectionChange">
      <el-table-column label="渠道" align="center" prop="source" />
      <el-table-column label="公司" align="center" prop="companyName" />
      <el-table-column label="销售" align="center" prop="nickName" />
      <el-table-column label="企微主体" align="center" prop="corpName" />
      <el-table-column label="企微员工" align="center" prop="qwUserName" />
	  <el-table-column label="添加时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
             size="mini"
             type="text"
             @click="handledetails(scope.row)"
             >详情
          </el-button>
       
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改联系我日志对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="app联系我id" prop="appWayId">
          <el-input v-model="form.appWayId" placeholder="请输入app联系我id" />
        </el-form-item>
        <el-form-item label="渠道" prop="source">
          <el-input v-model="form.source" placeholder="请输入渠道" />
        </el-form-item>
        <el-form-item label="用户id" prop="userId">
          <el-input v-model="form.userId" placeholder="请输入用户id" />
        </el-form-item>
        <el-form-item label="企微userId" prop="qwUserId">
          <el-input v-model="form.qwUserId" placeholder="请输入企微userId" />
        </el-form-item>
        <el-form-item label="公司id" prop="companyId">
          <el-input v-model="form.companyId" placeholder="请输入公司id" />
        </el-form-item>
        <el-form-item label="公司用户id" prop="companyUserId">
          <el-input v-model="form.companyUserId" placeholder="请输入公司用户id" />
        </el-form-item>
        <el-form-item label="企业CorpID" prop="corpId">
          <el-input v-model="form.corpId" placeholder="请输入企业CorpID" />
        </el-form-item>
        <el-form-item label="外部联系人id" prop="externalUserId">
          <el-input v-model="form.externalUserId" placeholder="请输入外部联系人id" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
	   <el-drawer
		:with-header="false" 
	        size="75%"
	         :title="show.title" :visible.sync="show.open">
	     <QwAppContactWayLogsDetails  ref="Details" />
	   </el-drawer>

  </div>
</template>

<script>
import { listQwAppContactWayLogs, getQwAppContactWayLogs, delQwAppContactWayLogs, addQwAppContactWayLogs, updateQwAppContactWayLogs, exportQwAppContactWayLogs } from "@/api/qw/qwAppContactWayLogs";
import { allCorp } from "@/api/qw/qwCompany";
import QwAppContactWayLogsDetails from "@/views/qw/qwAppContactWayLogs/details";
import {allList}from "@/api/company/company";
export default {
  name: "QwAppContactWayLogs",
  components: { QwAppContactWayLogsDetails },
  data() {
    return {
	show:{
			title:"详情",
			open:false,
		  },
	  companyList:[],
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
	  corpOptions: [],
      // 联系我日志表格数据
      qwAppContactWayLogsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        appWayId: null,
        source: null,
        userId: null,
        qwUserId: null,
        companyId: null,
        companyUserId: null,
        corpId: null,
        externalUserId: null,
		sTime:null,
		eTime:null,
      },
	   createTime:null,
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        userId: [
          { required: true, message: "用户id不能为空", trigger: "blur" }
        ],
      }
    };
  },
  created() {
    this.getList();
	 allList().then(response => {
		this.companyList = response.rows;
	});
	allCorp().then(response => {
		this.corpOptions = response.data;
	});
  },
  methods: {
    /** 查询联系我日志列表 */
    getList() {
      this.loading = true;
      listQwAppContactWayLogs(this.queryParams).then(response => {
        this.qwAppContactWayLogsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
	change(){
	      if(this.createTime!=null){
	        this.queryParams.sTime=this.createTime[0];
	        this.queryParams.eTime=this.createTime[1];
	      }else{
	        this.queryParams.sTime=null;
	        this.queryParams.eTime=null;
	      }
	    },
	handledetails(row){
		this.show.open=true;
		setTimeout(() => {
			 this.$refs.Details.getDetails(row.id);
		}, 1);
	},

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        appWayId: null,
        source: null,
        userId: null,
        qwUserId: null,
        companyId: null,
        companyUserId: null,
        corpId: null,
        externalUserId: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
	   this.createTime=null;
	  this.queryParams.sTime=null;
	  this.queryParams.eTime=null;
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加联系我日志";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getQwAppContactWayLogs(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改联系我日志";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateQwAppContactWayLogs(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addQwAppContactWayLogs(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除联系我日志编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delQwAppContactWayLogs(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有联系我日志数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportQwAppContactWayLogs(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    }
  }
};
</script>
